!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DynImpFunc
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: dynimpfunc.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $ 
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview 
!
!ˡѤʡؿη׻. 
!deepconv/arare ǤϻʬȤ He-VI ˡѤƤΤ, 
!ʡؿϱˡǲ.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Υ, 岼ȤƱľ®٤ͿƤ. 
!  *  2 ٤ΥۤѤƤ뤿, differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module DynImpFunc
  !
  !ˡѤϳزγƹη׻⥸塼.
  !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥη, 
  ! LU ʬ, LAPACK δؿΥåѡ. 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify     !å
  use gridset, only: DelZ,               &! z γʻֳ
    &                DimXMin,            &! x β
    &                DimXMax,            &! x ξ
    &                DimZMin,            &! z β
    &                DimZMax,            &! z ξ
    &                RegXMin,            &! x ʪΰβ
    &                RegXMax,            &! x ʪΰξ
    &                RegZMin,            &! z ʪΰβ
    &                RegZMax              ! z ʪΰξ
  use timeset,  only: DelTimeShort        !û֥ƥå
  use damping,  only: DampSound           !Ȥθ그
  use basicset, only: CpDry,             &!ʬǮ
    &                 xz_VelSoundBasicZ, &!ܾβ® 
    &                 xz_DensBasicZ,     &!ܾ̩
    &                 xz_PotTempBasicZ,  &!ܾβ
    &                 xz_EffMolWtBasicZ   !ܾʬ̸
  use average,  only: xr_avr_xz
  use differentiate_center2, only: xr_dz_xz, xz_dz_xr, xz_dx_pz

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public DynImpFunc_init   !롼
  public xz_Exner          !ʡؿη׻
  public xr_GradPi


  real(8)               :: beta  = 5.0d-1    !󥯥˥륽ˡʤ 0.5
                                             !ˡʤ 1
  integer               :: LN                !Υ
  real(8), allocatable  :: A(:)              !
  real(8), allocatable  :: B(:)              !
  real(8), allocatable  :: C(:)              !
  real(8), allocatable  :: B2(:)             !(LU ʬ)
  real(8), allocatable  :: IPIV(:)           !LU ʬ...
  real(8), allocatable  :: xz_F1BasicZ(:,:)  !η׻Ѥ
  real(8), allocatable  :: xr_F2BasicZ(:,:)  !η׻Ѥ
  real(8), allocatable  :: xz_VPotTempBasicZ(:,:) 
                                             !ܾβ

  !ͤ¸
  save beta, LN, A, B, C, B2, IPIV
  save xz_F1BasicZ, xr_F2BasicZ, xz_VPotTempBasicZ

contains

!!!--------------------------------------------------------------------!!!
  subroutine DynImpFunc_init()
    !
    !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥ, 
    !LU ʬԤ. 
    !

    !ۤηػ
    implicit none
  
    !γդ
    allocate(  &
      & A(RegZMin+1:RegZMax),   &
      & B(RegZMin+2:RegZMax),   &  
      & C(RegZMin+1:RegZMax-1), &  
      & B2(RegZMin+3:RegZMax),  &
      & xz_F1BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &  
      & xr_F2BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_VPotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
      & IPIV(RegZMin+1:RegZMax) )
    
    !̤
    xz_VPotTempBasicZ = xz_PotTempBasicZ / xz_EffMolWtBasicZ

    !η׻
    xz_F1BasicZ = ( xz_VelSoundBasicZ ** 2.0d0 ) &
      &           / (CpDry * xz_DensBasicZ *(xz_VPotTempBasicZ ** 2.0d0))
    
    xr_F2BasicZ = xr_avr_xz( &
      & CpDry * xz_DensBasicZ * (xz_VPotTempBasicZ ** 2.0d0) )
    
    A(RegZMin+2: RegZMax-1) = &
      & 1.0d0 + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &  
      &   * ( xr_F2BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &
      &       +  xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-2) ) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
    
    A(RegZMin+1) = 1.0d0 &
      & + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+1)  &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)

    A(RegZMax) = 1.0d0 &
      & + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMax)  &
      &   * xr_F2BasicZ(RegXMax, RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
    
    B(RegZMin+2: RegZMax) = &
      & - ( beta ** 2.0d0 ) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )
    
    C(RegZMin+1: RegZMax-1) = &
      & - ( beta ** 2.0d0 ) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+2: RegZMax) &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )

    !礭ݴ
    LN = RegZMax - RegZMin 

    ! LU ʬ (LAPACK)
    call LinSolvLU(A, B, C, B2, IPIV)
    
  end subroutine DynImpFunc_init
  

!!!--------------------------------------------------------------------!!!
  function xz_Exner(xr_FzNl, pz_VelXNs, pz_VelXAs, xr_VelZNs, xz_ExnerNs)
    !
    !ˡѤʡؿη׻. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)      :: pz_VelXNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !® u []
    real(8), intent(in)      :: pz_VelXAs(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !® u [+]
    real(8), intent(in)      :: xr_VelZNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !® w []
    real(8), intent(in)      :: xr_FzNl(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !Z γϹ[t]
    real(8), intent(in)      :: xz_ExnerNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !̵
    real(8)                  :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !̵[+]

    !ѿ
    real(8)               :: D(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: E(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: F(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: xz_DivVelNs(DimXMin:DimXMax, DimZMin:DimZMax)
    integer               :: i
    
    !®٤μ«׻
    xz_DivVelNs =  xz_dx_pz( pz_VelXNs ) + xz_dz_xr( xr_VelZNs )
  
    !׻Τη
    E = xr_dz_xz( DampSound * xz_DivVelNs )                         &
      & - ( 1.0d0 - beta ) * xr_dz_xz( xz_ExnerNs )                 &
      & + xr_FzNl / xr_avr_xz( CpDry * xz_VPotTempBasicZ ) 
    
    F = - beta * xz_F1BasicZ * DelTimeShort                         &
      & * xz_dz_xr( xr_avr_xz( xz_DensBasicZ * xz_VPotTempBasicZ)   &
      &   * (                                                       &
      &       xr_VelZNs                                             &
      &       - xr_avr_xz(CpDry * xz_VPotTempBasicZ) * DelTimeShort &
      &         * ( (1.0d0 - beta) * xr_dz_xz( xz_ExnerNs )         &
      &             - xr_dz_xz( DampSound * xz_DivVelNs ) )         &
      &       + xr_FzNl * DelTimeShort                              &
      &      )                                                      &
      &   ) 
    
    D = xz_ExnerNs                                                       &
      & - (1.0d0 - beta)                                                  &
      &   * xz_F1BasicZ * DelTimeShort                                    &
      &   * xz_dz_xr(                                                     &
      &       xr_avr_xz(xz_DensBasicZ * xz_VPotTempBasicZ) * xr_VelZNs   &
      &     )                                                             &
      & - (xz_VelSoundBasicZ ** 2.0d0) * DelTimeShort                     & 
      &   / (CpDry * xz_VPotTempBasicZ)                                   &
      &   * xz_dx_pz( pz_VelXAs )                                        &
      & + F
    
    D(:, RegZMin+1) = D(:, RegZMin+1)                                  &
      & - beta * xz_F1BasicZ(:, RegZMin+1) * ( DelTimeShort ** 2.0d0 ) &
      &   * xr_F2BasicZ(:, RegZMin) * E(:,RegZMin)                     &
      &   / DelZ
    
    D(:, RegZMax) = D(:, RegZMax) &
      & + beta * xz_F1BasicZ(:, RegZMax) * ( DelTimeShort ** 2.0d0 )   &
      &   * xr_F2BasicZ(:, RegZMax) * E(:, RegZMax)                    &
      &   / DelZ     

    !ϢΩ켡β
    do i = RegXMin + 1, RegXMax
      call LinSolv( D(i, RegZMin+1: RegZMax) )
    end do
    
    !D ͤ
    xz_Exner = D
    
  end function xz_Exner


!!!--------------------------------------------------------------------!!!
  subroutine LinSolv(D)
    !
    !LU ʬ򤵤Ƥ 3 ϢΩ 1 (). LAPACK 
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(inout) :: D(1,LN)      !/
    integer                :: NRHS
    integer                :: INFO
    integer                :: LDB
    character(1),parameter :: TRANS = 'N'

    !ѿν
    NRHS = 0
    INFO = 0
    LDB = LN
    
    !η׻. LAPACK . 
    call DGTTRS(TRANS, LN, NRHS, C, A, B, B2, IPIV, D, LDB, INFO)

!    !Υǥå. 
!    if (INFO /= 0) then
!      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!       stop
!     end if
     
  end subroutine LinSolv


!!!--------------------------------------------------------------------!!!
  subroutine LinSolvLU(A, B, C, B2, IPIV)
    !
    ! 3  LU ʬ(). LAPACK 
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(inout)         :: A(LN)      !
    real(8), intent(inout)         :: B(LN-1)    !
    real(8), intent(inout)         :: C(LN-1)    !
    real(8), intent(out)           :: B2(LN-2)   !
    real(8), intent(out)           :: IPIV(LN)   !ʬԥܥåȸ򴹤ξǼ
    integer                        :: INFO

    !ѿν
    INFO = 0
    
    !η׻. LAPACK . 
    call DGTTRF(LN, C, A, B, B2, IPIV, INFO)
    
!    !Υǥå. 
!    if (INFO /= 0) then
!       call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!       stop
!    end if
    
  end subroutine LinSolvLU


!!!--------------------------------------------------------------------!!!
  function xr_GradPi(xz_ExnerA, xz_ExnerN, pz_VelX, xr_VelZ)
    !
    ! x ȾʻҤ줿ǤΰϷϹη׻. 
    ! 󥯡˥륽ˡѤ뤿,    +ӤǤ
    ! ʡؿͤȤƼ.
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xz_ExnerA(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʡؿξ
    real(8), intent(in)  :: xz_ExnerN(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʡؿξ
    real(8), intent(in)  :: pz_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʿ®
    real(8), intent(in)  :: xr_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ľ®
    real(8)              :: xr_GradPi(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϸ
    real(8)              :: xz_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !®٤μ«

    !®٤μ«
    xz_DivVel =  xz_dx_pz( pz_VelX ) + xz_dz_xr( xr_VelZ )
    
    !® w ΰϸ
    xr_GradPi = 0.0d0
    xr_GradPi =   &
      & xr_avr_xz(CpDry * xz_PotTempBasicZ / xz_EffMolWtBasicZ )   &
      &   * (                                                      &
      &       beta * xr_dz_xz( xz_ExnerA )                         &
      &       + (1.0d0 - beta) * xr_dz_xz( xz_ExnerN )             &
      &       - xr_dz_xz( DampSound * xz_DivVel )                  &
      &     )                                              
    
  end function xr_GradPi
  
  
end module DynImpFunc
