!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine WarmRainPrm
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: warmrainprm.f90,v 1.1.1.1 2006/04/25 03:43:58 deepconv Exp $
!   * Tag Name: $Name: arare4-20060426 $
!   * Change History: 
!
!== Overview
!
!ȤΥХ륯ˡѤ, ȱ, ȱκѴ.
!   *  (1994) Ѥ꼰򤽤Τޤ. 
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

module WarmRainPrm
  !
  !ȤΥХ륯ˡѤ, ȱ, ȱκѴ.
  !   *  (1994) Ѥ꼰򤽤Τޤ. 
  ! 
  
  !⥸塼ɤ߹
  use gridset, only:  DimXMin,           &! x β
    &                 DimXMax,           &! x ξ
    &                 DimZMin,           &! z β
    &                 DimZMax,           &! z ξ
    &                 SpcNum              !ؼο
  use basicset, only: CpDry,             &!ʬǮ
    &                 MolWtWet,          &!
    &                 SpcWetID,          &!
    &                 SpcWetSymbol,      &!
    &                 xz_DensBasicZ,     &!ܾ̩
    &                 xz_PotTempBasicZ,  &!ܾβ
    &                 xz_ExnerBasicZ,    &!̵ܾ
    &                 xz_MixRtBasicZ      !ܾκ
  use average,  only: xz_avr_xr        
  use differentiate_center4, only: xr_dz_xz
  use ChemData, only: ChemData_OneSpcID
  use ChemCalc, only: SvapPress, LatentHeatPerMass
  use MoistFunc,only: Vap2MixRt, xz_DelMixRtNH4SH
  
  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public ˤ
  public WarmRainPrm_Init
  public xz_LatentHeatRain2Gas
  public xz_Rain2Gas
  public xz_Cloud2Rain
  public xz_Cloud2RainNH4SH
  public xz_FallRain

  real(8)       :: MinError = 1.0d-12  !и
  integer      :: LoopNum      = 0
  integer      :: GasNum(10)   = 0
  integer      :: CloudNum(10) = 0
  integer      :: RainNum(10) = 0
  integer      :: NH3Num   = 0
  integer      :: H2SNum   = 0
  integer      :: NH4SHCloudNum = 0
  integer      :: NH4SHRainNum = 0
  real(8), allocatable :: RainSW(:)
  
  save MinError
  save LoopNum, RainNum, CloudNum, GasNum
  save NH3Num, H2SNum, NH4SHCloudNum, NH4SHRainNum
  save RainSW

contains  

!!!=================================================================================!!!
  subroutine WarmRainPrm_Init()

    !ۤηػ
    implicit none

    !ѿ
    integer                  :: s
    integer                  :: n1, n2, LoopNum2

    !-----------------------------------------------------------
    ! γȱγȵΤ ID Ȥ
    !-----------------------------------------------------------
    !
    allocate( RainSW(SpcNum) )
    LoopNum  = 0
    LoopNum2 = 0
    RainSW   = 0.0d0

    !ؼ椫鱫γΤ, źʬ̤ݴ.
    SelectCloud: do s = 1, SpcNum

      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-Cloud' )
      if (n1 /= 0) then
        LoopNum           = LoopNum + 1
        GasNum(LoopNum)   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
        CloudNum(LoopNum) = s
      end if

      !'Rain' Ȥʸ󤬴ޤޤΤθĿ
      n2 = index(SpcWetSymbol(s), '-Rain' )
      if (n2 /= 0) then
        LoopNum2          = LoopNum2 + 1
        RainNum(LoopNum2) = s
        RainSW(s)         = 1.0d0
      end if

      ! NH4SH ¸ߤ LoopNum  1 ĸ餹
      if ( trim(SpcWetSymbol(s)) == 'NH4SH-s-Cloud' ) then 
        LoopNum = LoopNum - 1
      end if

    end do SelectCloud
    
    !-----------------------------------------------------------
    ! β˥, ӥ˥βǤ ID 
    !   'Cloud'  'Rain' ¸ߤȲꤷƤ
    !-----------------------------------------------------------
    NH3Num   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH3-g'))
    H2SNum   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('H2S-g'))
    NH4SHCloudNum = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH4SH-s'))
    NH4SHRainNum  = NH4SHCloudNum + 1

    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    if ( LoopNum == 0 ) then 
      write(*,*) "WarmRainPrm: CloudNum = 0, please comment out of WarmRainPrm"
!      stop
    end if

    write(*,*) "WarmRainPrm_Init, LoopNum:  ", LoopNum
    write(*,*) "WarmRainPrm_Init, GasNum:   ", GasNum    
    write(*,*) "WarmRainPrm_Init, CloudNum: ", CloudNum
    write(*,*) "WarmRainPrm_Init, RainNum:  ", RainNum    
    write(*,*) "WarmRainPrm_Init, RainSW:   ", RainSW
    write(*,*) "WarmRainPrm_Init, NH3Num:   ", NH3Num
    write(*,*) "WarmRainPrm_Init, H2SNum:   ", H2SNum
    write(*,*) "WarmRainPrm_Init, NH4SHNum: ", NH4SHCloudNum
    write(*,*) "WarmRainPrm_Init, NH4SHNum: ", NH4SHRainNum

  end subroutine WarmRainPrm_Init


!!!=================================================================================!!!  
  function xz_Rain2Gas(xz_Exner, xz_PotTemp, xz_MixRt)
    !
    ! γؤѴ̤׻뤿Υ롼
    !
    ! Ѵ̤, ȱγκ̤ʤΤ, ׻
    ! ͤˤʤ뤳ȤݾڤƤ. ޤ, ¸ߤʾαγ
    ! Ѵʤ褦, αγѴ̤ξ¤ȤƤ.
    !
        
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !̤ξʬ
    real(8), intent(in) :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !٤ξʬ 
    real(8), intent(in) :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ
    real(8)             :: xz_Rain2Gas(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !
    real(8)             :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !٤ξʬ + ʿʬ
    real(8)             :: xz_MixRtAll(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ + ʿʬ
    real(8)             :: NonSaturate    !̤˰(˰ºȾκκ)
    integer             :: s, i, k

    !, , ̤
    !ʬʿʬ­
    xz_TempAll  = ( xz_PotTemp + xz_PotTempBasicZ ) *  ( xz_Exner + xz_ExnerBasicZ )
    xz_MixRtAll(:,:,:)   = xz_MixRt(:,:,:) + xz_MixRtBasicZ(:,:,:)
    xz_Rain2Gas(:,:,:) = 0.0d0
    
    do s = 1, LoopNum
      do k = DimZMin, DimZmax
        do i = DimXMin, DimXMax
          
          !˰¾Ⱥκ(̤˰)׻. 
          !  ؤѴ̤̤˰٤˱.
          NonSaturate =                                              &
            & Vap2MixRt(                                             &
            &     MolWtWet(CloudNum(s)),                             &
            &     SvapPress(SpcWetID(CloudNum(s)), xz_TempAll(i,k)), &
            &     (xz_Exner(i,k) + xz_ExnerBasicZ(i,k))              &
            &   )                                                    &
            & - xz_MixRtAll(i,k, GasNum(s))
  
          !Ѵ
          !  αγκʾ˾ȯʤ褦˾ͤ
          xz_Rain2Gas(i,k,RainNum(s)) =                              &
            & - min(                                                   &
            &        4.85d-2 * max(0.0d0, NonSaturate )                &
            &        * (                                               &
            &             max( 0.0d0, xz_MixRtAll(i,k,RainNum(s)) )    &
            &             * xz_DensBasicZ(i,k)                         &
            &           ) ** 0.65d0 ,                                  &
            &        max( 0.0d0, xz_MixRtAll(i,k,RainNum(s)) )         &
            &      )

          !Ѵ
          !  γѴ̤Ȥ椬դȤʤ
          xz_Rain2Gas(i,k,GasNum(s)) = - xz_Rain2Gas(i,k,RainNum(s)) 
        end do
      end do
    end do

!    write(*,*) 'R2V: ', minval(xz_Rain2Gas(:,:,1)), maxval(xz_Rain2Gas(:,:,1))
!    write(*,*) 'R2V: ', minval(xz_Rain2Gas(:,:,2)), maxval(xz_Rain2Gas(:,:,2))
!    write(*,*) 'R2V: ', minval(xz_Rain2Gas(:,:,3)), maxval(xz_Rain2Gas(:,:,3))
    
  end function xz_Rain2Gas
    

!!!=================================================================================!!!  
  function xz_LatentHeatRain2Gas(xz_Exner, xz_PotTemp, xz_MixRt)
    !
    ! γؤѴ̤׻뤿Υ롼
    !
    ! Ѵ̤, ȱγκ̤ʤΤ, ׻
    ! ͤˤʤ뤳ȤݾڤƤ. ޤ, ¸ߤʾαγ
    ! Ѵʤ褦, αγѴ̤ξ¤ȤƤ.
    !
        
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !̤ξʬ
    real(8), intent(in) :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !٤ξʬ 
    real(8), intent(in) :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ
    real(8)             :: xz_LatentHeatRain2Gas(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !
    real(8)             :: xz_Rain2Gas(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !
    real(8)             :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !٤ξʬ + ʿʬ
    real(8)             :: xz_MixRtAll(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ + ʿʬ
    real(8)             :: NonSaturate    !̤˰(˰ºȾκκ)
    integer             :: s, i, k

    !, , ̤
    !ʬʿʬ­
    xz_TempAll  = ( xz_PotTemp + xz_PotTempBasicZ ) *  ( xz_Exner + xz_ExnerBasicZ )
    xz_MixRtAll(:,:,:)   = xz_MixRt(:,:,:) + xz_MixRtBasicZ(:,:,:)
    xz_Rain2Gas(:,:,:) = 0.0d0
    xz_LatentHeatRain2Gas(:,:) = 0.0d0
    
    do s = 1, LoopNum
      do k = DimZMin, DimZmax
        do i = DimXMin, DimXMax
          
          !˰¾Ⱥκ(̤˰)׻. 
          !  ؤѴ̤̤˰٤˱.
          NonSaturate =                                              &
            & Vap2MixRt(                                             &
            &     MolWtWet(CloudNum(s)),                             &
            &     SvapPress(SpcWetID(CloudNum(s)), xz_TempAll(i,k)), &
            &     (xz_Exner(i,k) + xz_ExnerBasicZ(i,k))              &
            &   )                                                    &
            & - xz_MixRtAll(i,k, GasNum(s))
  
          !Ѵ
          !  αγκʾ˾ȯʤ褦˾ͤ
          xz_Rain2Gas(i,k,RainNum(s)) =                              &
            & - min(                                                   &
            &        4.85d-2 * max(0.0d0, NonSaturate )                &
            &        * (                                               &
            &             max( 0.0d0, xz_MixRtAll(i,k,RainNum(s)) )    &
            &             * xz_DensBasicZ(i,k)                         &
            &           ) ** 0.65d0 ,                                  &
            &        max( 0.0d0, xz_MixRtAll(i,k,RainNum(s)) )         &
            &      )
          
          !ؤѲȼȯǮ
          xz_LatentHeatRain2Gas(i,k) =                                   &
            & xz_LatentHeatRain2Gas(i,k)                                 &
            & + LatentHeatPerMass( SpcWetID(RainNum(s)), xz_TempAll(i,k) ) &
            &   * xz_Rain2Gas(i,k,RainNum(s)) 
          
        end do
      end do
    end do
    
  end function xz_LatentHeatRain2Gas
  

!!!=================================================================================!!!  
  function xz_Cloud2Rain( xz_MixRt )
    !
    ! γ鱫γؤѴ̤׻뤿Υ롼
    ! ʻĹ Kessler (1969) Υѥ᥿ꥼѤ, 
    ! ͹Ĺ Kessler (1969) Υѥ᥿ꥼѤ. 
    !
    ! Ѵ̤, γȱγκ̤ʤΤ, ׻
    ! ͤˤʤ뤳ȤݾڤƤ. ޤ, ¸ߤʾαγ
    ! γѴʤ褦, αγѴ̤ξ¤ȤƤ.
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ
    real(8)             :: xz_Cloud2Rain(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !鱫ؤѴ
    real(8)             :: xz_MixRtAll(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ + ʿʬ
    real(8)             :: xz_AutoConv(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !˰º
    real(8)             :: xz_Collect(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !ʲ줿Ǯ
!    real(8), parameter  :: N0 = 5.0d7 
!    real(8), parameter  :: D0 = 3.66d-1
    integer             :: i, k, s

    xz_MixRtAll = xz_MixRt + xz_MixRtBasicZ 
    xz_Cloud2Rain  = 0.0d0

    do s = 1, LoopNum
      xz_AutoConv = 0.0d0
      xz_Collect  = 0.0d0
      
      do k = DimZMin, DimZmax
        do i = DimXMin, DimXMax
          
          !ʻĹ
          !  Kessler (1969) Υѥ᥿ꥼ        
          xz_AutoConv(i,k) =                                                &
            & 1.0d-3 * max( 0.0d0, ( xz_MixRtAll(i,k,CloudNum(s)) - 1.0d-3) )

!          !  Berry (1968) Υѥ᥿ꥼ        
!          xz_AutoConv(i,k) =                                                &
!            & xz_DensBasicZ(i,k)                                            &
!            & * (                                                           &
!            &      max( 0.0d0, xz_MixRtAll(i,k,CloudNum(s)) ) ** 3.0d0      &
!            &    ) * 1.0d6                                                  &
!            & / 60.0d0 * (                                                  &
!            &       2.0d0 * max( 0.0d0, xz_MixRtAll(i,k,CloudNum(s)) )      &
!            &     + 60.0d0 * 2.66d-8 * N0 / ( xz_DensBasicZ(i,k) * D0 )     &
!            &    ) 
          
          !͹Ĺ
          !  Kessler (1969) Υѥ᥿ꥼ    
          xz_Collect(i,k) =                                                        &
            &  2.2d0 * max( 0.0d0, xz_MixRtAll(i,k, CloudNum(s)) )                 &
            &  * (                                                                 &
            &       max( 0.0d0, xz_MixRtAll(i,k,RainNum(s)) ) * xz_DensBasicZ(i,k) &
            &     ) ** 0.875d0  
         
          !Ѵ: ʻĹȹξͤ
          !  Ѳ̤ͤȤꤹ. ͤȤʤ.
          xz_Cloud2Rain(i,k,CloudNum(s)) =                         &
            & - min(                                               &
            &         max( 0.0d0, xz_MixRtAll(i,k,CloudNum(s)) ),  &
            &         ( xz_AutoConv(i,k) + xz_Collect(i,k) )       &
            &       )
          
          !Ѵ. ϱѴ̤Ȥȿ. 
          xz_Cloud2Rain(i,k,RainNum(s)) = - xz_Cloud2Rain(i,k,CloudNum(s)) 
          
        end do
      end do
    end do

!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,1)), maxval(xz_Cloud2Rain(:,:,1))
!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,2)), maxval(xz_Cloud2Rain(:,:,2))
!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,3)), maxval(xz_Cloud2Rain(:,:,3))
    
  end function xz_Cloud2Rain


!!!=================================================================================!!!
  function xz_Cloud2RainNH4SH( xz_MixRt )
    !
    ! γ鱫γؤѴ̤׻뤿Υ롼
    ! ʻĹ Kessler (1969) Υѥ᥿ꥼѤ, 
    ! ͹Ĺ Kessler (1969) Υѥ᥿ꥼѤ. 
    !
    ! Ѵ̤, γȱγκ̤ʤΤ, ׻
    ! ͤˤʤ뤳ȤݾڤƤ. ޤ, ¸ߤʾαγ
    ! γѴʤ褦, αγѴ̤ξ¤ȤƤ.
    !
    
    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(in) :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ
    real(8)             :: xz_Cloud2RainNH4SH(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !鱫ؤѴ
    real(8)             :: xz_MixRtAll(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                          !ξʬ + ʿʬ
    real(8)             :: xz_AutoConv(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !˰º
    real(8)             :: xz_Collect(DimXMin:DimXMax, DimZMin:DimZMax)
                                          !ʲ줿Ǯ
    integer             :: i, k

    xz_MixRtAll = xz_MixRt + xz_MixRtBasicZ 
    xz_Cloud2RainNH4SH  = 0.0d0
    xz_AutoConv = 0.0d0
    xz_Collect  = 0.0d0
      
    do k = DimZMin, DimZmax
      do i = DimXMin, DimXMax
          
        !ʻĹ
        !  Kessler (1969) Υѥ᥿ꥼ        
        xz_AutoConv(i,k) =                                                &
          & 1.0d-3 * max( 0.0d0, ( xz_MixRtAll(i,k,NH4SHCloudNum) - 1.0d-3) )

        !͹Ĺ
        !  Kessler (1969) Υѥ᥿ꥼ    
        xz_Collect(i,k) =                                                        &
          &  2.2d0 * max( 0.0d0, xz_MixRtAll(i,k, NH4SHCloudNum) )                 &
          &  * (                                                                 &
          &       max( 0.0d0, xz_MixRtAll(i,k,NH4SHRainNum) ) * xz_DensBasicZ(i,k) &
          &     ) ** 0.875d0  
        
        !Ѵ: ʻĹȹξͤ
        !  Ѳ̤ͤȤꤹ. ͤȤʤ.
        xz_Cloud2RainNH4SH(i,k,NH4SHCloudNum) =                  &
          & - min(                                               &
          &         max( 0.0d0, xz_MixRtAll(i,k,NH4SHCloudNum) ),&
          &         ( xz_AutoConv(i,k) + xz_Collect(i,k) )       &
          &       )
        
        !Ѵ. ϱѴ̤Ȥȿ. 
        xz_Cloud2RainNH4SH(i,k,NH4SHRainNum) = - xz_Cloud2RainNH4SH(i,k,NH4SHCloudNum) 
        
      end do
    end do
    
!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,1)), maxval(xz_Cloud2Rain(:,:,1))
!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,2)), maxval(xz_Cloud2Rain(:,:,2))
!    write(*,*) 'C2R: ', minval(xz_Cloud2Rain(:,:,3)), maxval(xz_Cloud2Rain(:,:,3))
    
  end function xz_Cloud2RainNH4SH


!!!=================================================================================!!!
  function xz_FallRain( xz_MixRt, num )
    !
    ! γˤή. 
    ! 
    ! Υ롼ΰ xz_MixRt  2 Ǥ. 
    ! Ϳ줿Ф, ή׻. 
    ! ⤷, xz_MixRt γκɽʤ(RainSW = 1)ʤ
    ! ͤϤ. 
    ! ⤷, xz_MixRt ⤷ϱγκɽʤ(RainSW = 0)
    ! ʤ, ˤήϥȤ. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    integer, intent(in) :: num
    real(8), intent(in) :: xz_MixRt(DimXMin:DimXMax, DimZMin:DimZMax)  
                                                 !()
    real(8)             :: xz_MixRtAll(DimXMin:DimXMax, DimZMin:DimZMax)  
                                                 !( + ʿѾ)
    real(8)             :: xz_FallRain(DimXMin:DimXMax, DimZMin:DimZMax)
                                                 !γ
    real(8)             :: xz_VelZRain(DimXMin:DimXMax, DimZMin:DimZMax)
                                                 !γ®

    xz_MixRtAll = xz_MixRt + xz_MixRtBasicZ(:,:,num)
    xz_FallRain = 0.0d0
    xz_VelZRain = 0.0d0

    where (xz_MixRt > 0.0d0) 
      
      !γü®
      xz_VelZRain = 12.2d0 * (xz_MixRtAll ** 0.125d0) 
      
      !ˤή
      !  Dens  avr äƤ, 䤬Τ
      xz_FallRain =                                                     &
        &  xz_avr_xr(                                                  &
        &         xr_dz_xz(xz_DensBasicZ * xz_VelZRain * xz_MixRtAll)   &
        &      ) / xz_DensBasicZ                                        &
        &        * RainSW(num)
      
    end where

!    write(*,*) 'MixRt: ', minval( xz_MixRt    ),  maxval( xz_MixRt    )
!    write(*,*) 'Fall:  ', minval( xz_FallRain ),  maxval( xz_FallRain )

  end function xz_FallRain
  
end module WarmRainPrm
